IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'IMPOSTO_ITEMPEDIDO'  and
            type = 'P'                  and
            u.uid = o.uid               and
            u.name = USER)
  DROP PROCEDURE IMPOSTO_ITEMPEDIDO
  GO

CREATE PROCEDURE IMPOSTO_ITEMPEDIDO @P_EMPRESA    VARCHAR(2),
                                    @P_INSCESTA   VARCHAR(16),
                                    @P_CLIENTE    VARCHAR(21),
                                    @P_FILIDEST   VARCHAR(4),
                                    @P_FILIAL     VARCHAR(4),
                                    @P_NRPEDIDO   VARCHAR(10),
                                    @P_NRITEMPED  VARCHAR(10),
                                    @P_INIVALID   DATETIME,
                                    @P_CDTIPOOPER VARCHAR(2),
                                    @P_IDTIPOOPER VARCHAR(1)

AS
   DECLARE @V_PAISORIG     VARCHAR(04);
   DECLARE @V_ESTAORIG     VARCHAR(02);
   DECLARE @V_MUNIDEST     VARCHAR(04);
   DECLARE @V_PAISDEST     VARCHAR(04);
   DECLARE @V_ESTADEST     VARCHAR(02);
   DECLARE @V_ALIQTEMP     VARCHAR(18);
   DECLARE @V_INCITEMP     VARCHAR(18);
   DECLARE @V_CARACFIS     VARCHAR(01);
   DECLARE @V_NRITEMPED    VARCHAR(04);
   DECLARE @V_NRIMPDIGI    INT;
   DECLARE @V_LIQUIITEM    NUMERIC(15,6);
   DECLARE @V_PARDEDTMP    NUMERIC(15,6);
   DECLARE @V_PREDBCTMP    NUMERIC(15,6);
   DECLARE @V_ALIQUTMP     NUMERIC(15,6);
   DECLARE @V_IMPOSTOIT    NUMERIC(15,6);
   DECLARE @V_TAXABASECALC NUMERIC(15,6);
   DECLARE @V_TAXABCSUBSTR NUMERIC(15,6);
   DECLARE @V_TAXAALIQUOTA NUMERIC(15,6);
   DECLARE @V_BASECALCIT   NUMERIC(15,6);
   DECLARE @V_CONTABCALC   NUMERIC(15,6);
   DECLARE @V_PERDBCALC    NUMERIC(15,6);
   DECLARE @V_ADIMPAF      NUMERIC(15,6);
   DECLARE @V_TOTAIMPBCALC NUMERIC(15,6);
   DECLARE @V_TOTAPRODENCA NUMERIC(15,6);
   DECLARE @V_PRODUENCARGO NUMERIC(15,6);
   DECLARE @V_VRPBCSTTMP   NUMERIC(15,6);
   DECLARE @V_RETIRAICMS   NUMERIC(15,6);
   DECLARE @V_CDIMPOSTRIB  VARCHAR(02);
   DECLARE @V_IDVRIMPSTRIB VARCHAR(01);
   DECLARE @V_IMPOSTOICMS  VARCHAR(02);
   DECLARE @V_IDINTEREST   VARCHAR(01);
   DECLARE @V_IDINTERNA    VARCHAR(01);
   DECLARE @V_IDPMCBASECAL VARCHAR(01);
   DECLARE @V_VRPEMAXVENDA NUMERIC(15,6);
   DECLARE @V_VRMAXVENDA   NUMERIC(15,6);
   DECLARE @V_CALCVLRMAX   NUMERIC(15,6);
   DECLARE @V_BASEVLRMAX   NUMERIC(15,6);
   DECLARE @V_CTSTRIB      NUMERIC(15,6);
   DECLARE @V_TRATIMPST    VARCHAR(1);
   DECLARE @V_VRIMPOSTOST  NUMERIC(15,6);

   /*VARIVEIS DO CURSOR C_ITEMPEDIDO*/
   DECLARE @V_ITEMPEDIDO_QTITEMPED    NUMERIC(10,3);
   DECLARE @V_ITEMPEDIDO_VRPREUNITPED NUMERIC(15,5);
   DECLARE @V_ITEMPEDIDO_VRDESITPED   NUMERIC(15,5);
   DECLARE @V_ITEMPEDIDO_CDPRODUTO    VARCHAR(10);
   DECLARE @V_ITEMPEDIDO_CDARVPROD    VARCHAR(20);
   DECLARE @V_ITEMPEDIDO_CDMARCA      VARCHAR(5);
   DECLARE @V_ITEMPEDIDO_DTENTITPED   DATETIME;

   /*VARIVEIS DO CURSOR C_INCIDENCIA*/
   DECLARE @V_INCIDEN_CDIMPOTEMP  VARCHAR(2);
   DECLARE @V_INCIDEN_CDFISCTEMP  VARCHAR(1);
   DECLARE @V_INCIDEN_IDTRATIMPO  VARCHAR(1);
   DECLARE @V_INCIDEN_IDIMPORECUP VARCHAR(1);
   DECLARE @V_INCIDEN_IDUTVLRQTDEIMPO VARCHAR(1);

   /*VARIVEIS DO CURSOR C_PRODUTO*/
   DECLARE @V_PRODUTO_CDPRODUTO    VARCHAR(10);
   DECLARE @V_PRODUTO_DTENTITPED   DATETIME;
   DECLARE @V_PRODUTO_CDIMPOSTO    VARCHAR(2);
   DECLARE @V_PRODUTO_VRPEDREDBCITPED NUMERIC(10,2);
   DECLARE @V_PRODUTO_VRALIQITPED  NUMERIC(10,2);
   DECLARE @V_PRODUTO_VRPARCDEDITPED  NUMERIC(16,2);
   DECLARE @V_PRODUTO_CDFISCALITPED  VARCHAR(1);
   DECLARE @V_PRODUTO_VRIMPOSTOITPED   NUMERIC(16,2);
   DECLARE @V_PRODUTO_IDTRATIMPO   VARCHAR(1);
   DECLARE @V_PRODUTO_IDIMPORECUP  VARCHAR(1);
   DECLARE @V_PRODUTO_CDARVPROD    VARCHAR(20);
   DECLARE @V_STRING_AUX           VARCHAR(2000);
   DECLARE @V_VRIMPITAFAUX         NUMERIC(16,2);

   DECLARE @V_CDGRUPOFISC          VARCHAR(3);

   DECLARE @V_IDTRATIMPBC   VARCHAR(1);
   DECLARE @V_IDIMPORECUPBC VARCHAR(1);

   DECLARE @V_CSTTEMP  VARCHAR(18);
   DECLARE @V_CFOPTEMP VARCHAR(18);

   DECLARE @V_FISOPEITEM VARCHAR(11);
   DECLARE @V_SITUTRIBPR VARCHAR(03);

   DECLARE @V_AUX VARCHAR(10);
   DECLARE @V_AUX2 VARCHAR(10);

   DECLARE @V_IDUTILVRMAX      VARCHAR(01);
   DECLARE @V_VRDESCMAXVENDA   FLOAT;
   DECLARE @V_FINALVRMAXVENDA  FLOAT;
   DECLARE @V_VRFATOCONVES     FLOAT;
   DECLARE @V_CDFISCOPERREGRA  VARCHAR(10);
   DECLARE @V_CFOP1DIGT        VARCHAR(01);

   /*VARIVEIS DO CURSOR C_CFOPICMS*/
   DECLARE @V_CFOPICMS_CDIMPOSTO       VARCHAR(02);
   DECLARE @V_CFOPICMS_CDIMPOSTRIB     VARCHAR(02);
   DECLARE @V_CFOPICMS_NRITEMPED       VARCHAR(10)
   DECLARE @V_CFOPICMS_CDFISCOPERITPED VARCHAR(10);
BEGIN
   SET @V_NRITEMPED = SUBSTRING(@P_NRITEMPED,7,4);
   SET @V_CSTTEMP   = @P_FILIAL+@P_NRPEDIDO+@V_NRITEMPED;
   SET @V_CFOPTEMP  = @P_FILIAL+@P_NRPEDIDO+@V_NRITEMPED;
   SET @V_RETIRAICMS = 0;

   IF @P_IDTIPOOPER = 'C' BEGIN
      EXEC CONSULTA_GRUPOFISCAL 'C', @P_CLIENTE, '', 'S', @P_CDTIPOOPER,  @P_CDGRUPOFISC = @V_CDGRUPOFISC OUTPUT;
   END
   ELSE IF @P_IDTIPOOPER = 'L' BEGIN
      EXEC CONSULTA_GRUPOFISCAL 'L', @P_FILIDEST, '', 'S', @P_CDTIPOOPER, @P_CDGRUPOFISC = @V_CDGRUPOFISC OUTPUT;
   END;

--Variveis com a chave para as tabelas temporrias

   SET @V_ALIQTEMP = @P_FILIAL+@P_NRPEDIDO+@V_NRITEMPED;
   SET @V_INCITEMP = @P_FILIAL+@P_NRPEDIDO+@V_NRITEMPED;
---------------------------------------------------------------------------------------------------------

--Variveis para consulta de Alquota, Incidncia
   SELECT @V_PAISORIG = MAX(CDPAIS),
          @V_ESTAORIG = MAX(SGESTADO)
   FROM INSCRESTAD
   WHERE (CDEMPRESA  = @P_EMPRESA) AND
         (CDINSCESTA = @P_INSCESTA);

   IF @P_IDTIPOOPER = 'C' BEGIN
      SELECT @V_PAISDEST = MAX(CDPAIS),
             @V_ESTADEST = MAX(SGESTADO),
             @V_MUNIDEST = MAX(CDMUNICIPIO)
      FROM ENDECLIE
      WHERE (CDCLIENTE   = @P_CLIENTE) AND
            (IDTPENDECLIE = 'P');
   END
   ELSE IF @P_IDTIPOOPER = 'L' BEGIN
      SELECT @V_PAISDEST = MAX(CDPAIS),
             @V_ESTADEST = MAX(SGESTADO),
             @V_MUNIDEST = MAX(CDMUNICIPIO)
      FROM ENDEFILI
      WHERE (CDFILIAL   = @P_FILIDEST) AND
            (IDTPENDEFILI = 'P');
   END;

   SELECT @V_CARACFIS = MAX(IDCARACFIS)
   FROM PARAMFILIAL
   WHERE CDFILIAL = @P_FILIAL;

   SET @V_IDINTEREST = 'N';
   SET @V_IDINTERNA  = 'N';
   IF ((@V_PAISDEST = @V_PAISORIG) AND (@V_ESTADEST <> @V_ESTAORIG)) BEGIN
      SET @V_IDINTEREST = 'S';
   END;

   IF (@V_PAISDEST <> @V_PAISORIG) BEGIN
      SET @V_IDINTERNA = 'S';
   END;
---------------------------------------------------------------------------------------------------------

-- Atualizao da tabela de ItemPedido

   DELETE IMPITEMPEDIDO
   WHERE (CDFILIAL    = @P_FILIAL)    AND
         (NRPEDIDO    = @P_NRPEDIDO)  AND
         (NRITEMPED   = @P_NRITEMPED);

   DECLARE C_ITEMPEDIDO CURSOR FOR
   SELECT QTITEMPED, VRPREUNITPED, VRDESITPED, ITEMPEDIDO.CDPRODUTO,
          CDARVPROD, DTENTITPED
   FROM ITEMPEDIDO,
        PRODUTO
   WHERE CDFILIAL   = @P_FILIAL AND
         NRPEDIDO   = @P_NRPEDIDO AND
         ITEMPEDIDO.CDPRODUTO = PRODUTO.CDPRODUTO AND
         NRITEMPED = @P_NRITEMPED;

   OPEN C_ITEMPEDIDO;

   FETCH NEXT FROM C_ITEMPEDIDO INTO @V_ITEMPEDIDO_QTITEMPED, @V_ITEMPEDIDO_VRPREUNITPED,
                                     @V_ITEMPEDIDO_VRDESITPED, @V_ITEMPEDIDO_CDPRODUTO,
                                     @V_ITEMPEDIDO_CDARVPROD, @V_ITEMPEDIDO_DTENTITPED;

   WHILE (@@FETCH_STATUS = 0)
   BEGIN

      IF (@V_ITEMPEDIDO_VRDESITPED IS NULL)
      BEGIN
         SET @V_LIQUIITEM = (@V_ITEMPEDIDO_VRPREUNITPED * @V_ITEMPEDIDO_QTITEMPED);
      END
      ELSE
      BEGIN
         SET @V_LIQUIITEM = (@V_ITEMPEDIDO_VRPREUNITPED * @V_ITEMPEDIDO_QTITEMPED) * ((100 - @V_ITEMPEDIDO_VRDESITPED)/100);
      END;


      SET @V_STRING_AUX = @P_FILIAL+@P_NRPEDIDO;
      EXEC CONSULTA_INCIDENCIA 'S',  @P_EMPRESA,  @V_ITEMPEDIDO_CDARVPROD, @P_INSCESTA,
                               @P_CDTIPOOPER, @V_STRING_AUX, @V_NRITEMPED, @V_CDGRUPOFISC, NULL, 'PED',
                               NULL, NULL, @P_CLIENTE, @P_INIVALID, NULL, @V_LIQUIITEM, NULL;

---------------------------------------------------------------------------------------------------------
--Atualizao da tabela de impostos por item.
         /*IMPOSTO DE SUBSTITUICAO TRIBUTARIA*/

      DECLARE C_INCIDENCIA CURSOR FOR
      SELECT DISTINCT (CDIMPOTEMP) AS CDIMPOTEMP, CDFISCTEMP,
             IP.IDTRATIMPO, IP.IDIMPORECUP, IP.IDUTVLRQTDEIMPO
        FROM INCITEMP IT, IMPOSTO IP
       WHERE (IT.NRINCITEMP = @V_INCITEMP)    AND
             (IP.CDIMPOSTO  = IT.CDIMPOTEMP) AND
             (IP.IDPRODNOTA = 'P') AND
             (IP.CDIMPOSTRIB IS NOT NULL)
      UNION
      SELECT DISTINCT (CDIMPOTEMP) AS CDIMPOTEMP, CDFISCTEMP,
             IP.IDTRATIMPO, IP.IDIMPORECUP, IP.IDUTVLRQTDEIMPO
        FROM INCITEMP IT, IMPOSTO IP
       WHERE (IT.NRINCITEMP = @V_INCITEMP)    AND
             (IP.CDIMPOSTO  = IT.CDIMPOTEMP) AND
             (IP.IDPRODNOTA = 'P') AND
             (IP.CDIMPOSTRIB IS NULL);/*UNION PARA QUE FORCE IMPOSTO ICMS COMUM A SER O PRIMEIRO DA LISTA, POIS PARA QUE
                                                                 O ICMS POSSA SER DIMINUIDO DO ST,   PRECISO QUE COMUM SEJA CALCULADO PRIMEIRA*/

      OPEN C_INCIDENCIA;
      FETCH NEXT FROM C_INCIDENCIA INTO @V_INCIDEN_CDIMPOTEMP, @V_INCIDEN_CDFISCTEMP,
                                        @V_INCIDEN_IDTRATIMPO, @V_INCIDEN_IDIMPORECUP,
                                        @V_INCIDEN_IDUTVLRQTDEIMPO;

      WHILE (@@FETCH_STATUS = 0)
      BEGIN
         SET @V_STRING_AUX = @P_FILIAL+@P_NRPEDIDO;
         EXEC CONSULTA_ALIQUOTA @V_INCIDEN_CDIMPOTEMP, 'S', @P_EMPRESA,
                                @V_ITEMPEDIDO_CDARVPROD, @P_INSCESTA, @V_PAISORIG,
                                @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST, @V_MUNIDEST,
                                @V_LIQUIITEM, @P_INIVALID, @V_STRING_AUX, @V_NRITEMPED, @V_CDGRUPOFISC, NULL, 'PED';

         SET @V_PARDEDTMP  = 0;
         SET @V_PREDBCTMP  = 0;
         SET @V_ALIQUTMP   = 0;
         SET @V_IMPOSTOIT  = 0;
         SET @V_IDPMCBASECAL = 'N';

         SELECT @V_PARDEDTMP  = MAX(VRPARDEDTMP),
                @V_PREDBCTMP  = MAX(VRPREDBCTMP),
                @V_ALIQUTMP   = MAX(VRALIQUTMP),
                @V_VRPBCSTTMP = MAX(VRPBCSTTMP),
                @V_IDPMCBASECAL = ISNULL(MAX(IDPMCBSCALTMP), 'N'),
                @V_CDFISCOPERREGRA = MAX(CDFISCOPER)
         FROM ALIQTEMP
         WHERE (NRALIQTEMP = @V_ALIQTEMP);

         IF (@V_CDFISCOPERREGRA IS NOT NULL) BEGIN
            IF (@V_PAISORIG = @V_PAISDEST) BEGIN
               IF (@V_ESTAORIG = @V_ESTADEST) BEGIN
                  SET @V_CFOP1DIGT = '5';
               END
               ELSE BEGIN
                  SET @V_CFOP1DIGT = '6';
               END;
            END
            ELSE BEGIN
               SET @V_CFOP1DIGT = '7';
            END;
            SET @V_FISOPEITEM = @V_CFOP1DIGT+@V_CDFISCOPERREGRA;
         END;
         
         IF (@V_VRPBCSTTMP IS NULL) BEGIN
            SET @V_VRPBCSTTMP = 0;
         END;

         IF (@V_ALIQUTMP IS NULL) BEGIN
            SET @V_ALIQUTMP = 0;
         END;

         IF (@V_PREDBCTMP IS NULL) BEGIN
            SET @V_PREDBCTMP = 0;
         END;

         IF (@V_PARDEDTMP IS NULL) BEGIN
             SET @V_PARDEDTMP = 0;
         END;

         SET @V_IDVRIMPSTRIB = null;
         SET @V_CDIMPOSTRIB  = null;

         /*IMPOSTO DE SUBSTITUICAO TRIBUTARIA*/
         BEGIN
            SELECT @V_CDIMPOSTRIB = CDIMPOSTO
              FROM IMPOSTO
             WHERE CDIMPOSTRIB = @V_INCIDEN_CDIMPOTEMP;
         END;

         /*IMPORTO ICMS ORIGINAL*/
         BEGIN
            SELECT @V_IMPOSTOICMS = CDIMPOSTO, @V_IDVRIMPSTRIB = IDVRIMPSTRIB
              FROM IMPOSTO
             WHERE CDIMPOSTRIB IS NOT NULL;
         END;

         BEGIN
            SELECT @V_VRMAXVENDA = ISNULL(MAX(VRMAXVENDA),0), @V_VRPEMAXVENDA = ISNULL(MAX(VRPEMAXVENDA),0),
                   @V_IDUTILVRMAX = ISNULL(MAX(IDUTILVRMAX), 'C'), @V_VRDESCMAXVENDA = ISNULL(MAX(VRDESCMAXVENDA),0)
            FROM VRMAXVENPROD A
            WHERE (CDPAIS   = @V_PAISDEST)          AND
                  (SGESTADO = @V_ESTADEST)          AND
                  (A.CDPRODUTO = @V_ITEMPEDIDO_CDPRODUTO );
         END;

         SET @V_TAXABASECALC = (100 - @V_PREDBCTMP)/100;
         SET @V_TAXAALIQUOTA = (@V_ALIQUTMP/100);
         SET @V_TAXABCSUBSTR = 1 + (@V_VRPBCSTTMP / 100);
         SET @V_BASECALCIT   = @V_LIQUIITEM * @V_TAXABASECALC;

         SET @V_PERDBCALC    = 100 - @V_PREDBCTMP;

         IF @V_VRPBCSTTMP > 0 BEGIN
            SET @V_BASECALCIT = (@V_BASECALCIT * @V_TAXABCSUBSTR);
            SET @V_PREDBCTMP  = @V_VRPBCSTTMP;
            SET @V_PERDBCALC  = 0;
         END;

         IF @V_VRMAXVENDA IS NOT NULL BEGIN
            IF @V_IDUTILVRMAX = 'C' BEGIN
               SET @V_FINALVRMAXVENDA = (@V_VRMAXVENDA - ((@V_VRDESCMAXVENDA/100) * @V_VRMAXVENDA)) * (@V_VRPEMAXVENDA/100);
            END
            ELSE BEGIN
               SET @V_FINALVRMAXVENDA = @V_VRMAXVENDA - ((@V_VRDESCMAXVENDA/100) * @V_VRMAXVENDA);
            END;

            SET @V_CALCVLRMAX   = @V_ITEMPEDIDO_QTITEMPED * @V_FINALVRMAXVENDA;
            SET @V_CALCVLRMAX   = @V_CALCVLRMAX * @V_TAXABASECALC;
            IF @V_VRPBCSTTMP > 0 BEGIN
               SET @V_CALCVLRMAX = (@V_CALCVLRMAX * @V_TAXABCSUBSTR);
               SET @V_PREDBCTMP  = @V_VRPBCSTTMP;
               SET @V_PERDBCALC  = 0;
            END;
            SET @V_BASEVLRMAX = ROUND(@V_CALCVLRMAX, 2);
         END;

         IF @V_CDIMPOSTRIB IS NULL BEGIN
            IF (@V_INCIDEN_IDUTVLRQTDEIMPO = 'S') BEGIN
               SELECT @V_VRFATOCONVES = ISNULL(MAX(VRFATOCONVES), 1)
                 FROM CONVPRODUTO
                WHERE CDPRODUTO = @V_ITEMPEDIDO_CDPRODUTO;

               SET @V_BASECALCIT  = (@V_ITEMPEDIDO_QTITEMPED * @V_VRFATOCONVES);
               SET @V_IMPOSTOIT   = ((@V_ITEMPEDIDO_QTITEMPED * @V_VRFATOCONVES) * @V_ALIQUTMP) - @V_PARDEDTMP;
            END
            ELSE BEGIN
               SET @V_IMPOSTOIT   = (@V_BASECALCIT * @V_TAXAALIQUOTA) - @V_PARDEDTMP;
            END;
         END
         ELSE BEGIN
            /* Se utilizar o PMC como comparativo  feito a comparao das bases de calculos j majoradas e/ou reduzidas.
               O maior  a nova base de clculo.
               Caso seja prioridade sempre ser o PMC j majorado e/ou reduzido.
            */
            IF ISNULL(@V_IDPMCBASECAL, 'N') = 'S' BEGIN
               IF @V_IDUTILVRMAX = 'C' BEGIN
                  IF @V_BASECALCIT > @V_BASEVLRMAX BEGIN
                     SET @V_IMPOSTOIT   = (@V_BASECALCIT * @V_TAXAALIQUOTA) - @V_PARDEDTMP;
                  END
                  ELSE BEGIN
                     SET @V_BASECALCIT  = @V_BASEVLRMAX;
                     SET @V_IMPOSTOIT   = (@V_BASEVLRMAX * @V_TAXAALIQUOTA) - @V_PARDEDTMP;
                  END;
               END
               ELSE BEGIN
                  SET @V_BASECALCIT  = @V_BASEVLRMAX;
                  SET @V_IMPOSTOIT   = (@V_BASEVLRMAX * @V_TAXAALIQUOTA) - @V_PARDEDTMP;
               END;
            END
            ELSE BEGIN
               SET @V_IMPOSTOIT   = (@V_BASECALCIT * @V_TAXAALIQUOTA) - @V_PARDEDTMP;
            END;
         END;

         SET @V_CONTABCALC = @V_LIQUIITEM - (@V_LIQUIITEM * @V_TAXABASECALC);
         SET @V_PERDBCALC  = 100 - @V_PREDBCTMP;


         IF @V_CDIMPOSTRIB IS NOT NULL
         BEGIN
            SELECT @V_IDVRIMPSTRIB = ISNULL(MAX(IDVRIMPSTRIB), 'N')
              FROM IMPITEMPEDIDO  I, IMPOSTO II
             WHERE (CDFILIAL    = @P_FILIAL)
               AND (NRPEDIDO    = @P_NRPEDIDO)
               AND (NRITEMPED   = @P_NRITEMPED)
               AND (CHARINDEX(II.CDIMPOSTO+'_', @V_CDIMPOSTRIB) > 0)
               AND (I.CDIMPOSTO = II.CDIMPOSTO);

             IF (@V_TRATIMPST = '1') OR (ISNULL(@V_IDVRIMPSTRIB, 'N') = 'N')
             BEGIN
                SET @V_VRIMPOSTOST = 0;
             END
             ELSE
             BEGIN
                SELECT @V_VRIMPOSTOST = ISNULL(VRIMPOSTOITPED,0)
                  FROM IMPITEMPEDIDO
                 WHERE (CDFILIAL    = @P_FILIAL)
                   AND (NRPEDIDO    = @P_NRPEDIDO)
                   AND (NRITEMPED   = @P_NRITEMPED)
                   AND (CHARINDEX(CDIMPOSTO+'_', @V_CDIMPOSTRIB) > 0);
             END;
             SET @V_IMPOSTOIT = @V_IMPOSTOIT - @V_VRIMPOSTOST;
         END;

         IF (@V_IMPOSTOIT < 0) BEGIN
            SET @V_IMPOSTOIT = 0;
         END;

         SET @V_ADIMPAF = 0;

         IF (@V_INCIDEN_IDTRATIMPO  = 'A') OR (@V_TRATIMPST = '0') BEGIN
            SET @V_ADIMPAF = @V_IMPOSTOIT;
         END
         ELSE BEGIN
            IF (@V_INCIDEN_IDTRATIMPO  = 'D') BEGIN
               SET @V_ADIMPAF = - @V_IMPOSTOIT;
            END;
         END;

         BEGIN
            SET @V_VRIMPITAFAUX = NULL;
            SELECT @V_VRIMPITAFAUX = MAX(VRIMPOSTOITPED)
            FROM IMPITEMPEDIDO
            WHERE (CDFILIAL    = @P_FILIAL)    AND
                  (NRPEDIDO    = @P_NRPEDIDO)  AND
                  (NRITEMPED   = @P_NRITEMPED) AND
                  (CDIMPOSTO   = @V_INCIDEN_CDIMPOTEMP);

            IF (@V_INCIDEN_IDTRATIMPO = 'A') OR
               (@V_INCIDEN_IDTRATIMPO = 'D') BEGIN
               IF (@V_INCIDEN_IDTRATIMPO = 'D') BEGIN
                   SET @V_VRIMPITAFAUX = - @V_VRIMPITAFAUX;
               END;

               UPDATE IMPITEMPEDIDO
               SET VRACREDESCITPED = ROUND(@V_VRIMPITAFAUX, 2)
               WHERE (CDFILIAL    = @P_FILIAL)    AND
                     (NRPEDIDO    = @P_NRPEDIDO)  AND
                     (NRITEMPED   = @P_NRITEMPED) AND
                     (CDIMPOSTO   = @V_INCIDEN_CDIMPOTEMP);
            END;

            IF @V_VRIMPITAFAUX IS NULL BEGIN
               INSERT INTO IMPITEMPEDIDO
                  (CDFILIAL, NRPEDIDO, NRITEMPED,
                  CDIMPOSTO, VRIMPOSTOITPED, VRPERREDBCITPED, VRBASECALCITPED,
                  VRALIQITPED, VRPARCDEDITPED, CDFISCALITPED, VRACREDESCITPED)
               VALUES
                  (@P_FILIAL, @P_NRPEDIDO, @P_NRITEMPED,
                  @V_INCIDEN_CDIMPOTEMP, ROUND(@V_IMPOSTOIT, 2), @V_PREDBCTMP, @V_BASECALCIT,
                  @V_ALIQUTMP, @V_PARDEDTMP, @V_INCIDEN_CDFISCTEMP, ROUND(@V_ADIMPAF, 2));
            END;
         END;

         DELETE ALIQTEMP
         WHERE NRALIQTEMP = @V_ALIQTEMP;

         FETCH NEXT FROM C_INCIDENCIA INTO @V_INCIDEN_CDIMPOTEMP, @V_INCIDEN_CDFISCTEMP,
                                           @V_INCIDEN_IDTRATIMPO, @V_INCIDEN_IDIMPORECUP,
                                           @V_INCIDEN_IDUTVLRQTDEIMPO;
      END;

      CLOSE C_INCIDENCIA;
      DEALLOCATE C_INCIDENCIA;

      DELETE INCITEMP
      WHERE NRINCITEMP = @V_INCITEMP;

      FETCH NEXT FROM C_ITEMPEDIDO INTO @V_ITEMPEDIDO_QTITEMPED, @V_ITEMPEDIDO_VRPREUNITPED,
                                        @V_ITEMPEDIDO_VRDESITPED, @V_ITEMPEDIDO_CDPRODUTO,
                                        @V_ITEMPEDIDO_CDARVPROD, @V_ITEMPEDIDO_DTENTITPED;
   END;

   CLOSE C_ITEMPEDIDO;
   DEALLOCATE C_ITEMPEDIDO;

   DECLARE C_CFOPICMS CURSOR FOR
      SELECT II.CDIMPOSTO, I.CDIMPOSTRIB, II.NRITEMPED, II.CDFISCOPERITPED
        FROM IMPITEMPEDIDO II, IMPOSTO I
       WHERE (II.CDFILIAL    = @P_FILIAL )
         AND (II.NRPEDIDO    = @P_NRPEDIDO)
         AND (II.CDIMPOSTO   = I.CDIMPOSTO)
         AND (I.CDIMPOSTONFE = '00')
      ORDER BY II.CDIMPOSTO DESC;
   OPEN C_CFOPICMS;
   FETCH NEXT FROM C_CFOPICMS INTO @V_CFOPICMS_CDIMPOSTO, @V_CFOPICMS_CDIMPOSTRIB,
                                   @V_CFOPICMS_NRITEMPED, @V_CFOPICMS_CDFISCOPERITPED;

   WHILE (@@FETCH_STATUS = 0)
   BEGIN

      UPDATE IMPITEMPEDIDO
      SET CDFISCOPERITPED = @V_CFOPICMS_CDFISCOPERITPED
      WHERE CDFILIAL = @P_FILIAL
        AND NRPEDIDO = @P_NRPEDIDO
        AND NRITEMPED = @V_CFOPICMS_NRITEMPED
        AND CDIMPOSTO = @V_CFOPICMS_CDIMPOSTRIB;

      UPDATE IMPITEMPEDIDO
      SET CDFISCOPERITPED = @V_CFOPICMS_CDFISCOPERITPED
      WHERE CDFILIAL = @P_FILIAL
        AND NRPEDIDO = @P_NRPEDIDO
        AND NRITEMPED = @V_CFOPICMS_NRITEMPED
        AND CDIMPOSTO NOT IN (SELECT II2.CDIMPOSTO
                                FROM IMPITEMPEDIDO II2, IMPOSTO I
                               WHERE II2.CDFILIAL = @P_FILIAL
                                 AND II2.NRPEDIDO = @P_NRPEDIDO
                                 AND II2.NRITEMPED = @V_CFOPICMS_NRITEMPED
                                 AND II2.CDIMPOSTO = I.CDIMPOSTO
                                 AND I.CDIMPOSTONFE = '00')
        AND CDIMPOSTO NOT IN (SELECT I.CDIMPOSTRIB
                                FROM IMPITEMPEDIDO II2, IMPOSTO I
                               WHERE II2.CDFILIAL = @P_FILIAL
                                 AND II2.NRPEDIDO = @P_NRPEDIDO
                                 AND II2.NRITEMPED = @V_CFOPICMS_NRITEMPED
                                 AND II2.CDIMPOSTO = I.CDIMPOSTO
                                 AND I.CDIMPOSTONFE = '00');
      FETCH NEXT FROM C_CFOPICMS INTO @V_CFOPICMS_CDIMPOSTO, @V_CFOPICMS_CDIMPOSTRIB,
                                      @V_CFOPICMS_NRITEMPED, @V_CFOPICMS_CDFISCOPERITPED;
   END;
   CLOSE C_CFOPICMS;
   DEALLOCATE C_CFOPICMS;
---------------------------------------------------------------------------------------------------------
--Clculo do Valor dos Impostos que contm outros impostos na sua Base de Clculo

   DECLARE C_PRODUTO CURSOR FOR
   SELECT IP.CDPRODUTO, IP.DTENTITPED, II.CDIMPOSTO, VRPERREDBCITPED,
          VRALIQITPED, VRPARCDEDITPED, CDFISCALITPED, VRIMPOSTOITPED, IDTRATIMPO,
          IM.IDIMPORECUP
   FROM ITEMPEDIDO IP, IMPITEMPEDIDO II, IMPOSTO IM
   WHERE (IP.CDFILIAL    = @P_FILIAL)      AND
         (IP.NRPEDIDO    = @P_NRPEDIDO)    AND
         (IP.NRITEMPED   = @P_NRITEMPED)   AND
         (II.CDFILIAL    = IP.CDFILIAL)    AND
         (II.NRPEDIDO    = IP.NRPEDIDO)    AND
         (II.NRITEMPED   = IP.NRITEMPED)   AND
         (IM.CDIMPOSTO   = II.CDIMPOSTO);

   OPEN C_PRODUTO;
   FETCH NEXT FROM C_PRODUTO INTO @V_PRODUTO_CDPRODUTO, @V_PRODUTO_DTENTITPED,
                                  @V_PRODUTO_CDIMPOSTO, @V_PRODUTO_VRPEDREDBCITPED,
                                  @V_PRODUTO_VRALIQITPED, @V_PRODUTO_VRPARCDEDITPED,
                                  @V_PRODUTO_CDFISCALITPED, @V_PRODUTO_VRIMPOSTOITPED,
                                  @V_PRODUTO_IDTRATIMPO, @V_PRODUTO_IDIMPORECUP;
                                  
   WHILE (@@FETCH_STATUS = 0)
   BEGIN
      SET @V_AUX  = @P_FILIAL+@P_NRPEDIDO;

      EXEC CONSULTA_CST 'S', @P_EMPRESA, @V_PRODUTO_CDPRODUTO, @P_INSCESTA, @P_CDTIPOOPER,
                        @V_AUX, @V_NRITEMPED, @V_CDGRUPOFISC, NULL, @V_IDINTEREST, @V_IDINTERNA, 'PED';

      SET @V_AUX  = @P_FILIAL+SUBSTRING(@P_NRPEDIDO,1,4);
      SET @V_AUX2 = SUBSTRING(@P_NRPEDIDO,5,6)+SUBSTRING(@P_NRITEMPED,7,4);
      EXEC CONSULTA_CFOP 'S', @P_EMPRESA, @V_PRODUTO_CDPRODUTO, @P_INSCESTA, @P_CDTIPOOPER, @V_PAISORIG,
                         @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST, @V_AUX, @V_NRITEMPED,
                         @V_CDGRUPOFISC, @V_PRODUTO_DTENTITPED;

   SET @V_FISOPEITEM = NULL;
      SELECT @V_FISOPEITEM = MAX(CDFISOPETMP)
      FROM CFOPTEMP
      WHERE NRCFOPTEMP = @V_CFOPTEMP;

      SET @V_SITUTRIBPR = NULL;
      SELECT @V_SITUTRIBPR = MAX(CDSITTRIBTMP)
      FROM CSTTEMP
      WHERE NRCSTTEMP = @V_CSTTEMP;
      
      SET @V_TOTAIMPBCALC  = NULL;
      SET @V_IDTRATIMPBC   = NULL;
      SET @V_IDIMPORECUPBC = NULL;
     SELECT @V_TOTAIMPBCALC = SUM(VRIMPOSTOITPED),
             @V_IDTRATIMPBC = MAX(IMPOSTO.IDTRATIMPO),
             @V_IDIMPORECUPBC = MAX(IDIMPORECUP)
        FROM ITEMPEDIDO IP, IMPITEMPEDIDO II, BASECALCTPOPER BC, IMPOSTO
       WHERE (BC.CDIMPOSTO = @V_PRODUTO_CDIMPOSTO)
         AND (BC.IDENTRSAIDOP = 'S')
         AND (BC.CDTIPOOPER = @P_CDTIPOOPER)
         AND (IP.CDFILIAL = @P_FILIAL)
         AND (IP.NRPEDIDO = @P_NRPEDIDO)
         AND (IP.NRITEMPED = @P_NRITEMPED)
         AND (II.CDFILIAL = IP.CDFILIAL)
         AND (II.NRPEDIDO = IP.NRPEDIDO)
         AND (II.NRITEMPED = IP.NRITEMPED)
         AND (IP.CDPRODUTO = @V_PRODUTO_CDPRODUTO)
         AND (IP.DTENTITPED = @V_PRODUTO_DTENTITPED)
         AND (II.CDIMPOSTO = BC.CDIMPOBCALC)
         AND (IMPOSTO.CDIMPOSTO = BC.CDIMPOBCALC)
         AND ((@V_SITUTRIBPR = BC.CDCSTIMPOTPOP)  OR (BC.CDCSTIMPOTPOP IS NULL))
         AND ((SUBSTRING(@V_FISOPEITEM,2,10) = BC.CDCFOPIMPOTPOP) OR (BC.CDCFOPIMPOTPOP IS NULL))
         AND ((II.CDFISCALITPED = BC.CDFISCIMPOTPOP) OR (BC.CDFISCIMPOTPOP IS NULL));

      IF @V_IDTRATIMPBC IS NULL BEGIN
         SELECT @V_TOTAIMPBCALC  = SUM(VRIMPOSTOITPED),
                @V_IDTRATIMPBC   = MAX(IMPOSTO.IDTRATIMPO),
                @V_IDIMPORECUPBC = MAX(IDIMPORECUP)
         FROM ITEMPEDIDO IP, IMPITEMPEDIDO II, BASECALC BC, IMPOSTO
         WHERE (BC.CDIMPOSTO   = @V_PRODUTO_CDIMPOSTO)   AND
               (IP.CDFILIAL    = @P_FILIAL)              AND
               (IP.NRPEDIDO    = @P_NRPEDIDO)            AND
               (IP.NRITEMPED   = @P_NRITEMPED)           AND
               (II.CDFILIAL    = IP.CDFILIAL)            AND
               (II.NRPEDIDO    = IP.NRPEDIDO)            AND
               (II.NRITEMPED   = IP.NRITEMPED)           AND
               (IP.CDPRODUTO   = @V_PRODUTO_CDPRODUTO)   AND
               (IP.DTENTITPED  = @V_PRODUTO_DTENTITPED) AND
               (II.CDIMPOSTO   = BC.CDIMPOBCALC)        AND
               (IMPOSTO.CDIMPOSTO = BC.CDIMPOBCALC)     AND
               ((@V_SITUTRIBPR = BC.CDCSTIMPO)  OR (BC.CDCSTIMPO  IS NULL)) AND
               ((SUBSTRING(@V_FISOPEITEM,2,10) = BC.CDCFOPIMPO) OR (BC.CDCFOPIMPO IS NULL)) AND
               ((II.CDFISCALITPED = BC.CDFISCIMPO) OR (BC.CDFISCIMPO IS NULL)) AND
               (BC.IDTIPOBCALC   = 'I');
      END;

      DELETE FROM CFOPTEMP
      WHERE NRCFOPTEMP = @V_CFOPTEMP;

      DELETE FROM CSTTEMP
      WHERE NRCSTTEMP = @V_CSTTEMP;

      IF NOT (@V_TOTAIMPBCALC IS NULL) BEGIN
         SELECT @V_CTSTRIB = COUNT(CDIMPOSTO)         
           FROM IMPOSTO
          WHERE CDIMPOSTRIB = @V_PRODUTO_CDIMPOSTO;

         /*VERIFICA SE  ICMS ST*/
         IF @V_CTSTRIB > 0 BEGIN
            SET @V_TAXABASECALC = 1 + (@V_PRODUTO_VRPEDREDBCITPED/100);
         END
         ELSE 
         BEGIN
            SET @V_TAXABASECALC = (100 - @V_PRODUTO_VRPEDREDBCITPED)/100;
         END;
         SET @V_TAXAALIQUOTA = (@V_PRODUTO_VRALIQITPED/100);

         SET @V_ADIMPAF = 0;

         IF (@V_IDTRATIMPBC = 'A') BEGIN
            SET @V_ADIMPAF = ((@V_TOTAIMPBCALC * @V_TAXABASECALC) * @V_TAXAALIQUOTA);
          
         END
         ELSE
         IF (@V_IDTRATIMPBC = 'D') BEGIN
            SET @V_ADIMPAF = - ((@V_TOTAIMPBCALC * @V_TAXABASECALC) * @V_TAXAALIQUOTA);
         
         END
         ELSE IF (@V_IDTRATIMPBC  = 'R') 
         BEGIN
            IF (@V_IDIMPORECUPBC = 'S') 
            BEGIN
               IF (@V_PRODUTO_CDFISCALITPED <> '1') 
               BEGIN
                  SET @V_ADIMPAF = - ((@V_TOTAIMPBCALC * @V_TAXABASECALC) * @V_TAXAALIQUOTA);
               END;
            END
            ELSE
            BEGIN
               SET @V_ADIMPAF = - ((@V_TOTAIMPBCALC * @V_TAXABASECALC) * @V_TAXAALIQUOTA);
            END;
         END;

         IF (@V_PRODUTO_IDTRATIMPO <> 'V') OR (@V_PRODUTO_IDTRATIMPO = 'R')
         BEGIN
            UPDATE IMPITEMPEDIDO
            SET VRBASECALCITPED = VRBASECALCITPED + (@V_TOTAIMPBCALC * @V_TAXABASECALC),
                VRIMPOSTOITPED  = ROUND(VRIMPOSTOITPED + ((@V_TOTAIMPBCALC * @V_TAXABASECALC) * @V_TAXAALIQUOTA), 2),
                VRACREDESCITPED     = ROUND(VRACREDESCITPED + @V_ADIMPAF, 2)
            WHERE (CDFILIAL    = @P_FILIAL)              AND
                  (NRPEDIDO    = @P_NRPEDIDO)            AND
                  (NRITEMPED   = @P_NRITEMPED)           AND
                  (CDIMPOSTO   = @V_PRODUTO_CDIMPOSTO);
         END;
      END;
      FETCH NEXT FROM C_PRODUTO INTO @V_PRODUTO_CDPRODUTO, @V_PRODUTO_DTENTITPED,
                                     @V_PRODUTO_CDIMPOSTO, @V_PRODUTO_VRPEDREDBCITPED,
                                     @V_PRODUTO_VRALIQITPED, @V_PRODUTO_VRPARCDEDITPED,
                                     @V_PRODUTO_CDFISCALITPED, @V_PRODUTO_VRIMPOSTOITPED,
                                     @V_PRODUTO_IDTRATIMPO, @V_PRODUTO_IDIMPORECUP;
   END;
   CLOSE C_PRODUTO;
   DEALLOCATE C_PRODUTO;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'IMPOSTO_ITEMPEDIDO','5.50.xxx';
GO
